note
	description: "[
		Test examples with arrays and regular expressions.
		First test fails as Result is False by default.
		Write your own tests.
		Included libraries:
			base and extension
			Espec unit testing
			Mathmodels
			Gobo structures
			Gobo regular expressions
		]"
	author: "JSO"
	date: "$Date$"
	revision: "$Revision 19.05$"

class
	TEST_EXAMPLE

inherit

	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- initialize tests
		do
			add_violation_case_with_tag ("positive_i", agent t1)
			add_boolean_case (agent t2)
			add_violation_case_with_tag ("child_pre", agent t3)
		end

feature -- tests

	t1
		local
			c: CHILD
		do
			comment ("t1: {CHILD}.cmd_1 has no precondition: as if require else FALSE was declared")
			create c

			-- {CHILD}.cmd_1 has no precondition: as if "require else FALSE" was declared.
			-- Combined with the inherited precondition from PARENT (i > 0):
			-- i > 0 \/ FALSE <=> i > 0

			c.cmd_1 (-2) -- parent precondition violation
		end

	t2: BOOLEAN
		local
			c: CHILD
		do
			comment ("t2: {CHILD}.cmd_2 has an explicit precondition TRUE")
			create c

			-- {CHILD}.cmd_2 has an explicit precondition TRUE.
			-- Combined with the inherited precondition from PARENT (i > 0):
			-- i > 0 \/ TRUE <=> TRUE

			c.cmd_2 (-2) -- no precondition violation (meaning that for cmd_1, it's not as if declaring `require else true`)
			Result := true
		end

	t3
		local
			c: CHILD
		do
			comment ("t3: {CHILD}.cmd_3 has an explicit precondition FALSE")
			create c

			-- {CHILD}.cmd_3 has an explicit precondition FALSE.
			-- Combined with the inherited precondition from PARENT (i > 0):
			-- i > 0 \/ FALSE <=> i > 0

			c.cmd_3 (2) -- no child precondition violation
			check true end -- just to make sure that we can reach this point
			c.cmd_3 (-2) -- child precondition violation (meaning that for cmd_1, it's as if declaring `require else`)
		end



end
